/*
	File: Shape.h

	Copyright (c) 1996, Adobe Systems Incorporated.
	All rights reserved.

	Utilities for Shape example selection module.
*/

#ifndef __Shape_H__
#define __Shape_H__

#include "PISelection.h"
#include "PIUtilities.h"

/*****************************************************************************/
/* Scripting keys */
#define ourSuiteID			'sdK8'
#define ourClassID			ourSuiteID
#define ourEventID			'shpE'
#define shapeTriangle		'shP0'
#define shapeSquare			'shP1'
#define shapeCircle			'shP2'
#define shapeStar			'shP3'
#define shapeTreble			'shP4'
#define	shapeRibbon			'shP5'
#define shapeNote			'shP6'
#define typeShape			'tshP'
#define keyCreate			'kcrE'
#define typeCreate			'tcrE'
#define typePISel			'tpiS'
#define	createSelection		'crE0'
#define createMaskpath		'crE1'
#define createLayer			'crE2'

/*****************************************************************************/
/* Any constants here */

#define kFirstItem			4
#define kLastItem			kFirstItem+6
#define kCreateRadio1		12
#define kCreateRadioLast	kCreateRadio1+2
#define PathResource		'Path'

/*****************************************************************************/

enum
{
	iShapeTriangle,
	iShapeSquare,
	iShapeCircle,
	iShapeStar,
	iShapeTreble,
	iShapeRibbon,
	iShapeNote
};

enum
{
	iCreateSelection,
	iCreateMaskpath,
	iCreateLayer
};

/*****************************************************************************/

extern Handle hDllInstance;

typedef struct Globals
	{
	short 	result;
	short	whatShape;
	short	create;
	Boolean	queryForParameters;
	PISelectionParams *selectionParamBlock;
	} Globals, *GPtr, **GHdl;
	
#define gResult (globals->result)
#define gStuff  (globals->selectionParamBlock)
#define gWhatShape (globals->whatShape)
#define gQueryForParameters (globals->queryForParameters)
#define gCreate (globals->create)

/*****************************************************************************/

void DoAbout (GPtr globals);
Boolean DoParameters (GPtr globals);
short KeyToEnum (OSType key, OSType whatType);
OSType EnumToKey (short keyEnum, OSType whatType);
Boolean ReadScriptParams (GPtr globals);
OSErr WriteScriptParams (GPtr globals);

/*****************************************************************************/

#if MSWindows
extern Handle hDllInstance; /* Dll for Windows; leave NULL for Mac */
#else //Mac
#define hDllInstance	NULL
#endif

#endif /* __Shape_H__ */
